unit ControlPanel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Gauges, ExtCtrls;

type
  TColor       = record
                     R,G,B : byte;
                    end;
  TScanRow     = array [0..1500] of TColor;
  TPixel       = array [1..2] of Integer;
  T2DPoint       = array [1..2] of Double;
  T3DPoint       = array [1..4] of Double;
  TnDPoint       = Record X,Y,Z:Double;
                          Xd,Yd:Integer;
                          Shade:Double;
                          Wrong:Boolean;
                   end;
  TVector        = array [1..3] of Double;

  TControl_Panel = class(TForm)
    Canvas_Button: TButton;
    Exit_Button: TButton;
    EditRov: TEdit;
    StaticText4: TStaticText;
    Image1: TImage;
    Scan_Button: TButton;
    StaticText1: TStaticText;
    EditCanvasMs: TEdit;
    StaticText2: TStaticText;
    EditMatrixMS: TEdit;
    StaticText5: TStaticText;
    StaticText3: TStaticText;
    EditRatio: TEdit;
    StaticText7: TStaticText;
    StaticText25: TStaticText;
    StaticText26: TStaticText;
    procedure Exit(Sender: TObject);
    procedure SetDraw3D(Sender: TObject);
    procedure Scan_Lines(Sender: TObject);
    procedure Canvas_Lines(Sender: TObject);
    procedure FuncCalcul(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
    x1,x2,y1,y2,i1,i2,j1,j2,k1,k2:Double;
    MajorRay,DirectOfLight:TVector;
    Parameter             :Double;
    Disp                  :Byte;
    Gloss,Light           :Double;
    Surface               :array [0..100,0..100] of TnDPoint;
    Klik                  :boolean;
    KlikX, KlikY          :Integer;
    Procedure Scale(x1,x2,y1,y2:Double);
    procedure View(Alfa,Beta:Double);
    procedure SetCenter(Alfa,Beta,Distance:Double;var Center:T3DPoint);
    Procedure PixelLine(A,B:TPixel;Color:Byte);
  {  Procedure ConstShading(Color:Byte);}
    Procedure Setting;
    Procedure Func_Values;
    Procedure Projection;
  end;

const slBlack=0;
      slWhite=255;
      slRed=5;
      slGreen=24;
      slBlue=179;
      NoOfAttempt=100;

var
  Control_Panel: TControl_Panel;

implementation

Type TTerm = record
               Character:Char;
               Value    :Double;
             end;
    TExpression = array [0..255] of TTerm;

var BackRed,BackGreen,BackBlue,
    RightRed,RightGreen,RightBlue,
    WrongRed,WrongGreen,WrongBlue:Byte;
    RedSegm,GreenSegm,BlueSegm   :Byte;
    CountOfSegments              :Integer;
    Code                         :Integer;
    hx,hy,AlfaView,BetaView,DeltaAlfa,
    AlfaLight,BetaLight,Distance,
    Fce_x1,Fce_x2,Fce_y1,Fce_y2  :Double;
    f                            :String;
    PreF                         :TExpression;
    Stop                         :Boolean;
    Red,Green,Blue               :Byte;
    Unit_X,Unit_Y                :Double;
    O,Center                     :T3DPoint;
    SL                           :PByteArray;
    MiliSeconds,CanvasMiliSeconds:Longint;
    MaxI,MaxJ                    :Integer;

{$R *.DFM}

Const Max     =255;                                    {maximalni dlka etzce}
      Cislice =['0'..'9','.'];
      BinOper =['^','*','/','+','-'];                        {binrn opertory}
      UnOper  =[#199..#211];

var   //Infix,Postfix:String;
      C,N,R,S,T,X,Y,Z:Double;                                        {Promnn}

//Pomocn funkce pro vyslen etezce

Function Prvek(Zapis:String;i:Integer; var Hodnota:Double; var Znak:Char):Boolean;
//Funkce pro ten zpisu po prvcch.
//vrac true, pokud se jet etl znak
//vrac znak "$" pokud se etlo slo

var j,Code    :Integer;
begin
    if i>Length(zapis)
          then Prvek:=False
          else begin
                 Prvek:=True;
                 if Zapis[i] in cislice
                    then begin
                           Znak:='$'; {na vstupu je slo}
                           j:=i;
                           Repeat
                             inc(i);
                           Until not(Zapis[i] in cislice);
                           Val(Copy(Zapis,j,i-j),Hodnota,Code);
                         end
                    else Znak:=Zapis[i]; {Precte jiny znak}
               end;
end;

//Pomocn funkce pro vyslen etezce

Function FunctionReplacement(Vstup:String):String;
// funkce zamuje zpisy matematickch funkc za jednopismenove priznaky
var i           :Integer;
    Vystup,Vypis:String;
begin
  for i:=1 to length(Vstup) do Vstup[i]:=UpCase(Vstup[i]);
  Vystup:='';
  i:=1;
  Repeat
       Case Vstup[i] of
        {funkce}
       '-':  begin
             if (i=1) or (Vstup[i-1]='(')
                                      then Vystup:=Vystup + #199  {unrn minus}
                                      else Vystup:=Vystup + Vstup[i];
              inc(i);
             end;
       '+':  begin
             if (i=1) or (Vstup[i-1]='(')
                                      then Vystup:=Vystup          {unrn plus}
                                      else Vystup:=Vystup + Vstup[i];
              inc(i);
             end;
       'S': Case Vstup[i+2] of
               'N':begin Vystup:=Vystup + #200;                          {sinus}
                         i:=i+3;
                   end;
               'R':begin
                   if Vstup[i+3]='T'
                   then begin Vystup:=Vystup + #207;i:=i+4;end {druha odmocnina}
                   else begin Vystup:=Vystup + #206;i:=i+3;end   {druha mocnina}
                   end;
               else begin Vystup:=Vystup+'S';inc(i);end;            {promnn S}
               end;
       'C':if Vstup[succ(i)]='O'
               then begin Vystup:=Vystup + #201;i:=i+3;end             {cosinus}
               else begin Vystup:=Vystup+'C';inc(i);                {promnn C}

                    end;
       'A':Case Vstup[i+3] of
                'T':begin Vystup:=Vystup + #204;i:=i+6;end;             {arctan}
                'S':begin Vystup:=Vystup + #209;i:=i+6;end;             {arcsin}
                'C':begin Vystup:=Vystup + #210;i:=i+6;end              {arccos}
                 else begin Vystup:=Vystup + #208;i:=i+3;end;              {abs}
               end;
       'E':begin Vystup:=Vystup + #202;i:=i+3;end;                         {exp}
       'L':begin Vystup:=Vystup + #203;i:=i+2;end;                          {ln}
       'T':if Vstup[succ(i)]='A'
             then begin Vystup:=Vystup + #205;i:=i+3;end                   {tan}
             else begin Vystup:=Vystup+'T';inc(i);end;              {promnn T}
       'F':begin Vystup:=Vystup + #211;i:=i+2;end;              {fa - faktoril}
       'P':begin Vystup:=Vystup+'P';i:=i+2;end;                  {Konstanta pi}
       {Promnn}
       'X':begin Vystup:=Vystup+'X';inc(i);end;                     {promnn X}
       'Y':begin Vystup:=Vystup+'Y';inc(i);end;                     {promnn Y}
       'Z':begin Vystup:=Vystup+'Z';inc(i);end;                     {promnn Z}
       'R':begin Vystup:=Vystup+'R';inc(i);end;                     {promnn R}
       'N':begin Vystup:=Vystup+'N';inc(i);end;                     {promnn N}
        else begin Vystup:=Vystup + Vstup[i];inc(i);end
       end;                                                               {Case}
  Until i>Length(Vstup);
  FunctionReplacement:=Vystup;
end;

Function PreExpres(Vstup:String;var Errorreport:String):TExpression;
Const Max = 255;                                     {maximalni pocet operatoru}
      NotInit = 0;                                    {neinicializovana hodnota}
var   Zasobnik  : TExpression;                               {Pracovni zasobnik}
      W         : 0..Max;                                     {Vrchol zasobniku}
      H         : Double;                                     {hodnoty operand}
      Z         : Char;                                         {znak na vstupu}
      Pokracovat: Boolean;
      i,j       : Integer;
      VypisCisla:String;
      Vystup    :TExpression;
      Term      :TTerm;
begin
  Vstup:=FunctionReplacement(Vstup);
  For j:=1 to max do
      With Vystup[j] do begin Value:=NotInit;Character:='%';end;
  w:=0;i:=1;j:=0;
  Pokracovat:=Prvek(Vstup,i,H,Z);
  While Pokracovat do
  begin
   Case Z of
   '$':With Vystup[j] do
       begin                                                {na vstupu je cislo}
             Value:=H;Character:='$';
             inc(j);
             i:=i+Length(FloatToStr(H));
       end;
   'P':With Vystup[j] do
       begin                                                   {na vstupu je pi}
             Value:=Pi;Character:='$';inc(j);inc(i);
       end;
   'C','N','R','S','T','X','Y','Z':
       With Vystup[j] do
       begin                                             {na vstupu je promenna}
             Value:=NotInit;Character:=Z;inc(j);inc(i);
       end;
   '(':begin                                              {zavorku do zasobniku}
             inc(W);
             Term.Character:='(';Term.Value:=NotInit;
             Zasobnik[w]:=Term;inc(i);
       end;
   ')':begin                                  {z vrcholu zasobniku az k zavorce}
         while (w>0) and (Zasobnik[w].Character<>'(') do
           begin  Vystup[j]:=Zasobnik[w];inc(j);dec(w) end;
           if w=0 then Errorreport:='Chybny vyraz'
                  else dec(w);                                 {zruseni zavorky}
         inc(i);
       end;
 '^' :  begin                                       {mocnina - ven ze zasobniku}
           while (w>0) and (Zasobnik[w].Character='^') do
             begin Vystup[j]:=Zasobnik[w];inc(j);dec(w) end;
             inc(w);
             Term.Character:=Z;Term.Value:=NotInit;
             Zasobnik[w]:=Term;                              {znak do zasobniku}
           inc(i);
         end;
 ' ' :inc(i);
 #199..#211:                    {operatory nejvyssi priority - ven ze zasobniku}
       begin
         while (w>0) and ((Zasobnik[w].Character in UnOper)
                     or (Zasobnik[w].Character='^')) do
             begin
                   Vystup[j]:=Zasobnik[w];
                   inc(j);dec(w) end;
             inc(w);Term.Character:=Z;Term.Value:=NotInit;
             Zasobnik[w]:=Term;                          {znak do zasobniku}
           inc(i);
       end;
 '/','*':begin                     {operatory nizsi priority - ven ze zasobniku}
           while (w>0) and (Zasobnik[w].Character in [#199..#211,'*','/','^']) do
             begin Vystup[j]:=Zasobnik[w];inc(j);dec(w) end;
             inc(w);Term.Character:=Z;Term.Value:=NotInit;
             Zasobnik[w]:=Term;                              {znak do zasobniku}
           inc(i);
         end;
 '+','-':begin                  {operatory nejnizsi priority - ven ze zasobniku}
           while (w>0) and (Zasobnik[w].Character in [#199..#211,'+','-','*','/','^']) do
             begin Vystup[j]:=Zasobnik[w];inc(j);dec(w) end;
             inc(w);Term.Character:=Z;Term.Value:=NotInit;
             Zasobnik[w]:=Term;                              {znak do zasobniku}
           inc(i);
         end
     end; {Case}
    Pokracovat:=Prvek(Vstup,i,H,Z);
  end;
  While (w>0) and (Zasobnik[w].Character<>'(') do
       begin                              {vyprazdnit pripadny zbytek zasobniku}
        Vystup[j]:=Zasobnik[w];inc(j);dec(w);
       end;
  PreExpres:=Vystup;
  if w>0 then Errorreport:='Chybny vyraz'
         else Errorreport:='';
end;                                                       {Procedure PreExpres}

Function PostExpres(Vstup:TExpression;var ErrorReport:String):Double;
Const TemerNula=1e-50;
var   Zasobnik,ZZZ  : TExpression;                 {zsobnk na hodnoty}
      i,w       : Integer;
      H,H1,H2   :Double;

Function Faktorial(N:LongInt):LongInt;
begin
  if n<2 then Faktorial:=1
         else Faktorial:=Faktorial(pred(n));
end;

Function Mocnina(Zaklad:Double;Exponent:LongInt):Double;
var i:LongInt;
    Moc:Double;
begin
  Moc:=1;
  for i:=1 to abs(Exponent) do Moc:=Moc*Zaklad;
  if Exponent<0 then Moc:=1/Moc;
  Mocnina:=Moc;
end;

begin
  ErrorReport:='';
{  for i:=0 to Max do begin
                       ZZZ[i].Character:=#150;
                       ZZZ[i].Value:=0;
                     end;}
  w:=-1;i:=0;
  While (Vstup[i].Character<>'%') do
  begin
    Case Vstup[i].Character of
   '$':begin inc(w);                                        {na vstupu je cislo}
             Zasobnik[w]:=Vstup[i];
             inc(i);
       end;
   'C','N','R','S','T','X','Y','Z':                      {na vstupu je promenna}
       begin
            inc(w);
            Case Vstup[i].Character of
            'C': Vstup[i].Value:=C;
            'N': Vstup[i].Value:=N;
            'R': Vstup[i].Value:=R;
            'S': Vstup[i].Value:=S;
            'T': Vstup[i].Value:=T;
            'X': Vstup[i].Value:=X;
            'Y': Vstup[i].Value:=Y;
            'Z': Vstup[i].Value:=Z;
            end;
           Zasobnik[w]:=Vstup[i];
           inc(i);
       end;
     '^','/','*', '+','-':             {binrn opertory}
        begin
          H1:=Zasobnik[w].Value;
          dec(w);
          H2:=Zasobnik[w].Value;
           Case Vstup[i].Character of
            '^':begin
                 if abs(H1)<TemerNula
                     then Zasobnik[w].Value:=0
                     else if H1=Round(h1)
                        then Zasobnik[w].Value:=Mocnina(H2,Round(H1))
                          else if h2>TemerNula
                              then Zasobnik[w].Value:=exp(H1*ln(H2))
                              else begin
                                    ErrorReport:='Zporn zklad reln mocniny';
                                    exit;
                                   end;
                end;
            '/':Zasobnik[w].Value:=H2 /   H1;
            '*':Zasobnik[w].Value:=H2 *   H1;
            '+':Zasobnik[w].Value:=H2 +   H1;
            '-':Zasobnik[w].Value:=H2 -   H1;
            end;
            inc(i);
          end;
                                           {funkce}
        #199:begin
              inc(i);Zasobnik[w].Value:=-Zasobnik[w].Value;      {unrn minus}
             end;
        #200:begin
              inc(i);Zasobnik[w].Value:=sin(Zasobnik[w].Value);          {sinus}
             end;
        #201:begin
              inc(i);Zasobnik[w].Value:=cos(Zasobnik[w].Value);        {cosinus}
             end;
        #202:begin
              inc(i);Zasobnik[w].Value:=exp(Zasobnik[w].Value);            {exp}
             end;
        #203:begin
              inc(i);
              if Zasobnik[w].Value>TemerNula
                          then Zasobnik[w].Value:=ln(Zasobnik[w].Value)     {ln}
                          else begin
                                ErrorReport:='Zporn argument logaritmu';
                                exit;
                               end;
             end;
        #204:begin
              inc(i);Zasobnik[w].Value:=arctan(Zasobnik[w].Value);      {arctan}
             end;
        #205:begin
              inc(i);                                                  {tangens}
              if abs(cos(Zasobnik[w].Value))>TemerNula
                            then Zasobnik[w].Value:=sin(Zasobnik[w].Value)/cos(Zasobnik[w].Value)
                            else begin
                                  ErrorReport:='Nedefinovan tangens';
                                  exit;
                                 end;
             end;
        #206:begin
              inc(i);Zasobnik[w].Value:=sqr(Zasobnik[w].Value);{druh mocnina}
             end;
        #207:begin
              inc(i);                                          {druh odmocnina}
              if Zasobnik[w].Value>=0
                      then Zasobnik[w].Value:=sqrt(Zasobnik[w].Value)
                      else begin
                           ErrorReport:='Zporn argument odmocniny';
                           exit;
                           end;
             end;
        #208:begin
              inc(i);Zasobnik[w].Value:=Abs(Zasobnik[w].Value);{absolutn hodnota}
             end;
        #209:begin                                                 {arcus sinus}
              inc(i);
              if abs(Zasobnik[w].Value)<1
                then Zasobnik[w].Value:=
                 arctan(Zasobnik[w].Value/sqrt(1-Zasobnik[w].Value*Zasobnik[w].Value))
                else if Zasobnik[w].Value=-1
                    then Zasobnik[w].Value:=-pi/2
                    else if Zasobnik[w].Value=1
                        then Zasobnik[w].Value:=pi/2
                        else begin
                              ErrorReport:='Neppustn argument arcsin';
                              exit;
                             end;
             end;
        #210:begin                                               {arcus cosinus}
              inc(i);
              if abs(Zasobnik[w].Value)<1
                then Zasobnik[w].Value:=pi/2-arctan(Zasobnik[w].Value/sqrt(1-Zasobnik[w].Value*Zasobnik[w].Value))
                else if Zasobnik[w].Value=-1
                    then Zasobnik[w].Value:=pi
                    else if Zasobnik[w].Value=1
                        then Zasobnik[w].Value:=0
                        else begin
                              ErrorReport:='Neppustn argument arccos';
                              exit;
                             end;
             end;
        #211:begin                                                   {faktoril}
               inc(i);
               if (Zasobnik[w].Value>=0) and (Round(Zasobnik[w].Value)=Zasobnik[w].Value)
                  then Zasobnik[w].Value:=Faktorial(Round(Zasobnik[w].Value))
                  else begin
                        ErrorReport:='Neppustn argument faktorilu';
                        exit;
                       end;
             end;
         end;                                                           {Case Z}
        end;
  While (w>0) do  dec(w);                 {vyprazdnit pripadny zbytek zasobniku}
  PostExpres:=Zasobnik[w].Value;
end;                                                                {PostExpres}

Procedure TControl_Panel.Scale(x1,x2,y1,y2:Double);
  begin
     Unit_X:= Image1.Width/(x2-x1);
     Unit_Y:= Image1.Height/(y2-y1);
     O[1]  := -x1*Unit_X;
     O[2]  :=  y2*Unit_Y;
  end;

  procedure TControl_Panel.View(Alfa,Beta:Double);
  var u,v                :TVector;
      SinAlfa,CosAlfa,i,j,k,
      CosGamma,CosDelta  :Double;
      O,S,X,Y,Z          :T3DPoint;

  Procedure SetVector(X,Y:T3DPoint;var v:TVector);
  begin v[1]:=Y[1]-X[1];v[2]:=Y[2]-X[2];v[3]:=Y[3]-X[3];end;

  Function ScalarProduct(u,v:TVector):Double;
  begin ScalarProduct:=u[1]*v[1]+u[2]*v[2]+u[3]*v[3];end;

  Procedure VectorProduct(r,s:TVector;var t:TVector);
  begin
   t[1]:= r[2]*s[3]-s[2]*r[3];t[2]:=-r[1]*s[3]+s[1]*r[3];t[3]:= r[1]*s[2]-s[1]*r[2];
  end;

  Function Norm(u:TVector):Double;
  begin Norm:=Sqrt(u[1]*u[1]+u[2]*u[2]+u[3]*u[3]);end;

  begin
  Alfa:=Pi*Alfa/180;Beta:=pi*Beta/180;
  S[1]:=cos(Alfa)*cos(Beta);S[2]:=sin(Alfa)*cos(Beta);S[3]:=sin(Beta);
  O[1]:=0;O[2]:=0;O[3]:=0;
  MajorRay[1]:=S[1];MajorRay[2]:=S[2];MajorRay[3]:=S[3];
  X[1]:=1/S[1];X[2]:=0;     X[3]:=0;
  Y[1]:=0;     Y[2]:=1/S[2];Y[3]:=0;
  Z[1]:=0;     Z[2]:=0;     Z[3]:=1/S[3];
  SetVector(S,X,u);SetVector(S,Z,v);
  CosGamma:=ScalarProduct(u,v)/Norm(u)/Norm(v);
  SetVector(S,Y,u);SetVector(S,Z,v);
  CosDelta:=ScalarProduct(u,v)/Norm(u)/Norm(v);
  SetVector(X,O,u);SetVector(X,S,v);
  i:=ScalarProduct(u,v)/Norm(u)/Norm(v);
  SetVector(Y,O,u);SetVector(Y,S,v);
  j:=ScalarProduct(u,v)/Norm(u)/Norm(v);
  SetVector(Z,O,u);SetVector(Z,S,v);
  k:=ScalarProduct(u,v)/Norm(u)/Norm(v);
  i1:=-i*sqrt(1-CosGamma*CosGamma);i2:=i*CosGamma;
  j1:=j*sqrt(1-CosDelta*CosDelta);j2:=j*CosDelta;
  k1:=0;                          k2:=cos(Beta);
  Parameter:=-MajorRay[1]*Center[1]-MajorRay[2]*Center[2]-MajorRay[3]*Center[3];
  end;

Procedure TControl_Panel.SetCenter(Alfa,Beta,Distance:Double;var Center:T3DPoint);
begin
  Center[1]:=Distance*cos(Alfa*pi/180)*cos(Beta*pi/180);
  Center[2]:=Distance*sin(Alfa*pi/180)*cos(Beta*pi/180);
  Center[3]:=Distance*sin(Beta*pi/180);
  Parameter:=-MajorRay[1]*Center[1]-MajorRay[2]*Center[2]-MajorRay[3]*Center[3];
end;

Procedure TControl_Panel.PixelLine(A,B:TPixel;Color:Byte);
var k1,k2,p,p1,p2,Dx,Dy,i :Integer;
    M                     :TPixel;
    Position              :Byte;
Begin
  Dx:=B[1]-A[1];
  if Dx<0 then
       begin
             p:=A[1];A[1]:=B[1];B[1]:=p;
             p:=A[2];A[2]:=B[2];B[2]:=p;
             Dx:=-Dx;
       end;
  Dy:=B[2]-A[2];M[1]:=A[1];M[2]:=A[2];
  SL:=Image1.Picture.Bitmap.ScanLine[M[2]];
  SL[M[1]]:=Color;
  if Dx=0 then
           if Dy>0 then Position:=1
                   else Position:=2
          else
           if Dy=Dx then Position:=3
                    else
                     if Dy=-Dx then Position:=4
                               else
                                if Dy>0 then
                                         if Dy>Dx then Position:=5
                                                  else Position:=6
                                        else
                                         if -Dy>Dx then Position:=7
                                                   else Position:=8;
 Case Position of
  1: For i:=succ(A[2]) to B[2] do
            begin
              SL:=Image1.Picture.Bitmap.ScanLine[i];
              SL[M[1]]:=Color;
            end;
  2: For i:=succ(B[2]) to A[2] do
            begin
              SL:=Image1.Picture.Bitmap.ScanLine[i];
              SL[M[1]]:=Color;
            end;
  3: For i:=succ(A[1]) to B[1] do
            begin
              SL:=Image1.Picture.Bitmap.ScanLine[M[2]];
              SL[M[1]]:=Color;
              inc(M[2]);
            end;
  4: For i:=succ(A[1]) to B[1] do
            begin
             SL:=Image1.Picture.Bitmap.ScanLine[M[2]];
             SL[M[1]]:=Color;
             dec(M[2]);
             end;
  5: begin
       p:=Dx;Dx:=Dy;Dy:=p;
       p1:=2*Dy;p2:=2*(Dy-Dx);p:=2*Dy-Dx;
       While M[2]<B[2] do
       begin
        Inc(M[2]);
        if p>0 then begin
                       Inc(M[1]);p:=p+p2;
                    end
                    else       p:=p+p1;
        SL:=Image1.Picture.Bitmap.ScanLine[M[2]];
        SL[M[1]]:=Color;
      end;
     end;
  6: begin
       p1:=2*Dy;p2:=2*(Dy-Dx);p:=2*Dy-Dx;SL:=Image1.Picture.Bitmap.ScanLine[M[2]];
       While M[1]<B[1] do
       begin
        inc(M[1]);
        if p>0 then begin
                      inc(M[2]);p:=p+p2;
                      SL:=Image1.Picture.Bitmap.ScanLine[M[2]];
                    end
                    else  p:=p+p1;
        SL[M[1]]:=Color;
       end;
      end;
  7: begin
       p:=Dx;Dx:=Dy;Dy:=-p;
       p1:=2*Dy;p2:=2*(Dy-Dx);p:=2*Dy-Dx;
       While M[2]>B[2] do
       begin
        dec(M[2]);
        if p<0 then begin
                     inc(M[1]);p:=p+p2;
                    end
                    else       p:=p+p1;
        SL:=Image1.Picture.Bitmap.ScanLine[M[2]];
        SL[M[1]]:=Color;
       end;
     end;
  8: begin
       Dy:=-Dy;SL:=Image1.Picture.Bitmap.ScanLine[M[2]];
       p1:=2*Dy;p2:=2*(Dy-Dx);p:=2*Dy-Dx;
       While M[1]<B[1] do
       begin
        inc(M[1]);
        if p>0 then begin
                      dec(M[2]);
                      p:=p+p2;
                      SL:=Image1.Picture.Bitmap.ScanLine[M[2]];
                    end
                    else  p:=p+p1;
       SL[M[1]]:=Color;
       end;
     end;
  end;
end;

(*  Procedure TControl_Panel.ConstShading(Color:Byte);
  Var R,G,B:Byte;
      i,j  :Integer;
      Xr,Yr,Zr,ZZr:TPixel;
   Procedure FillTriangle(X,Y,Z:TPixel);
   var i,j,Min1,Max1,Min2,Max2,h1,h2:Integer;
       Condition                :Boolean;
       Adr                      :LongInt;
   begin
      {*** ohraniceni trojuhelnika ****}
      PixelLine(X,Y,111);PixelLine(Y,Z,111);PixelLine(Z,X,111);
      Min1:=X[1];Max1:=X[1];Min2:=X[2];Max2:=X[2];
      if Y[1]<Min1 then Min1:=Y[1] else if Y[1]>Max1 then Max1:=Y[1];
      if Y[2]<Min2 then Min2:=Y[2] else if Y[2]>Max2 then Max2:=Y[2];
      if Z[1]<Min1 then Min1:=Z[1] else if Z[1]>Max1 then Max1:=Z[1];
      if Z[2]<Min2 then Min2:=Z[2] else if Z[2]>Max2 then Max2:=Z[2];
      for j:=Min2 to Max2 do
         begin
         h1:=Min1;dec(h1);SL:=Image1.Picture.Bitmap.ScanLine[j];
         Repeat
           Inc(h1);
           {End GetPixel}
         until (SL[h1]=111) or (h1>Max1);
         h2:=succ(Max1);
         Repeat
           dec(h2);
            {GetPixel [h2,i]}
            {End GetPixel}
          until (SL[h2]=111) or (h2<Min1);
          For i:=h1 to h2 do SL[i]:=Color;

         end;    {for i:=Min2 to max2 do}
     end; {FillTriangle}

  begin
    For i:=0 to MaxI-1 do
     For j:=0 To MaxJ-1 do
     Begin
      Xr[1]:=Surface[i,j].Xd;Xr[2]:=Surface[i,j].Yd;
      Yr[1]:=Surface[Succ(i),j].Xd;Yr[2]:=Surface[succ(i),j].Yd;
      Zr[1]:=Surface[succ(i),succ(j)].Xd;Zr[2]:=Surface[succ(i),succ(j)].Yd;
      ZZr[1]:=Surface[i,succ(j)].Xd;ZZr[2]:=Surface[i,succ(j)].Yd;
      FillTriangle(Xr,Yr,Zr);
      FillTriangle(Xr,Zr,ZZr);
     end;
  end; {ConstShadingSegment}*)


 Procedure TControl_Panel.Setting;
 begin
    X1:=-4;X2:=4;
    Y1:=-4.25;
    With Image1 do y2:=y1+(x2-x1)*Height/Width;
    Fce_X1:=-2.5;
    Fce_X2:=2.5;
    Fce_Y1:=-2.5;
    Fce_Y2:=2.5;
    AlfaView:=20;
    BetaView:=30;
    Distance:=30;
    f:=EditRov.Text;
    CountOfSegments:=60;
  end;  {Setting}

Procedure TControl_Panel.Func_Values;
var i,j:Integer;
    ErrorReport:String;
    Values     :array [0..255] of double;
begin
  hx:=(Fce_x2-Fce_x1)/CountOfSegments;hy:=(Fce_y2-Fce_y1)/CountOfSegments;
  y:=Fce_y1;j:=0;
  PreF:=PreExpres(f,ErrorReport);
  for i:=0 to 255 do Values[i]:=0;
  i:=0;
  Repeat
    x:=Fce_x1;i:=0;
    Repeat
       Surface[i,j].X:= x;
       Surface[i,j].Y:= y;
       Surface[i,j].Z:=PostExpres(PreF,ErrorReport);
       if ErrorReport<>'' then
            begin messagedlg(ErrorReport,mterror,[mbok],0);System.exit;end;
       x:=x+hx;inc(i);
     until x>Fce_x2;
     y:=y+hy;inc(j);
   until y>Fce_y2;
   MaxI:=i-2;MaxJ:=j-2;
end;

Procedure TControl_Panel.Projection;
var i,j:Integer;
    t  :Double;
    Xpp:T3DPoint;
    Xp :T2DPoint;
begin
  For i:=0 to succ(MaxI) do
    For j:=0 to Succ(MaxJ) do
     begin
    {Intersect(X,Xpp)}
      t:=Parameter/(Parameter+MajorRay[1]*Surface[i,j].X+MajorRay[2]*Surface[i,j].Y+MajorRay[3]*Surface[i,j].Z);
      Xpp[1]:=Center[1]+(Surface[i,j].X-Center[1])*t;
      Xpp[2]:=Center[2]+(Surface[i,j].Y-Center[2])*t;
      Xpp[3]:=Center[3]+(Surface[i,j].Z-Center[3])*t;
    {Projection(Xpp,Xp)}
      Xp[1]:=i1*Xpp[1]+j1*Xpp[2]+k1*Xpp[3];
      Xp[2]:=i2*Xpp[1]+j2*Xpp[2]+k2*Xpp[3];
     { Xd[1]:=XCoor(Xp[1]);Xd[2]:=YCoor(Xp[2]);}
     Surface[i,j].Xd:=trunc(O[1]+Unit_X*Xp[1]);
     Surface[i,j].Yd:=trunc(O[2]-Unit_Y*Xp[2]);
     end;
End;

procedure TControl_Panel.Exit(Sender: TObject);
begin
  Halt;
end;

procedure TControl_Panel.SetDraw3D(Sender: TObject);
Const Step=51;
var Table            : array[Byte] of TRGBQuad;
    Color,R,G,B      : Byte;
    RealR,RealG,RealB: Double;
    i,j              :Integer;
begin
    With Image1 do
    begin
      Align:=alNone;
      Picture.Bitmap.PixelFormat:=pf8bit;
      Picture.Bitmap.Width:=600;
      Picture.Bitmap.Height:=550;
      Width:=600;Height:=550;
    end;
    Visible:=True;
    With Image1.Picture.Bitmap do
  begin
  RealR:=0;RealG:=0;RealB:=0;
  R:=0;G:=0;B:=0;
  For Color:=0 to 214 do
  begin
   With Table[Color] do begin rgbRed:=R;rgbGreen:=G;rgbBlue:=B;rgbReserved:=0;end;
   RealR:=RealR+Step;
   if RealR>255 then
                     begin RealR:=0;RealG:=RealG+Step;end;
   if RealG>255 then
                     begin RealG:=0;RealB:=RealB+Step;end;
   R:=Round(RealR);G:=Round(RealG);B:=Round(RealB);
  end;
  For Color:=215 to 255 do
  begin
   With Table[Color] do begin rgbRed:=255;rgbGreen:=255;rgbBlue:=255;rgbReserved:=0;end;
  end;
   if SetDIBColorTable(Canvas.Handle,0,255,table)=0 then RaiseLastWin32Error;
   Canvas.Draw(0,0,Image1.Picture.Bitmap);
 end;
 CanvasMiliseconds:=-1;
 Miliseconds:=-1;
end;

procedure TControl_Panel.Scan_Lines(Sender: TObject);
var i,j,k,Code:Integer;
    A,B:TPixel;
    t1,t2:Real;
    Vypis:String;
begin
 Setting;
 Func_Values;
 Scale(x1,x2,y1,y2);
 SetCenter(AlfaView,BetaView,Distance,Center);
 View(AlfaView,BetaView);
 Projection;
   t1:=Time;
   For k:=0 to NoOfAttempt do
   begin
    For i:=0 to MaxI do
       For j:=0 to MaxJ do
       begin
        A[1]:=Surface[i,j].Xd;A[2]:=Surface[i,j].Yd;
        B[1]:=Surface[Succ(i),j].Xd;B[2]:=Surface[Succ(i),j].Yd;
        PixelLine(A,B,slRed);
        B[1]:=Surface[i,succ(j)].Xd;B[2]:=Surface[i,succ(j)].Yd;
        PixelLine(A,B,slRed);
       end;
   For j:=0 to MaxJ do
       begin
        A[1]:=Surface[i,j].Xd;A[2]:=Surface[i,j].Yd;
        B[1]:=Surface[i,succ(j)].Xd;B[2]:=Surface[i,succ(j)].Yd;
        PixelLine(A,B,slRed);
       end;
    j:=succ(MaxJ);
    For i:=0 to MaxI do
       begin
        A[1]:=Surface[i,j].Xd;A[2]:=Surface[i,j].Yd;
        B[1]:=Surface[Succ(i),j].Xd;B[2]:=Surface[Succ(i),j].Yd;
        PixelLine(A,B,slRed)
       end;
   end;
   Image1.Repaint;
   t2:=Time;
   Miliseconds:=Trunc((t2-t1)/1.1574e-8);
   Str(MiliSeconds,Vypis);
   EditMatrixMs.Text:=Vypis;
   if Miliseconds>0 then
         Str(MiliSeconds/CanvasMiliSeconds:7:5,Vypis)
                        else Vypis:='Infinity';
   if (CanvasMiliseconds>-1) and (Miliseconds>-1)  then EditRatio.Text:=Vypis;
end;

procedure TControl_Panel.Canvas_Lines(Sender: TObject);
var i,j,k,Code:Integer;
    A,B:TPixel;
    t1,t2:Real;
    Vypis:string;
begin
 Setting;
 Func_Values;
 Scale(x1,x2,y1,y2);
 SetCenter(AlfaView,BetaView,Distance,Center);
 View(AlfaView,BetaView);
 Projection;
  t1:=Time;
   For k:=0 to NoOfAttempt do
   begin
    For i:=0 to MaxI do
       For j:=0 to MaxJ do
       begin
        A[1]:=Surface[i,j].Xd;A[2]:=Surface[i,j].Yd;
        B[1]:=Surface[Succ(i),j].Xd;B[2]:=Surface[Succ(i),j].Yd;
        Image1.Picture.Bitmap.Canvas.MoveTo(Surface[i,j].Xd,Surface[i,j].Yd);
        Image1.Picture.Bitmap.Canvas.LineTo(Surface[Succ(i),j].Xd,Surface[succ(i),j].Yd);
        B[1]:=Surface[i,succ(j)].Xd;B[2]:=Surface[i,succ(j)].Yd;
        Image1.Picture.Bitmap.Canvas.MoveTo(Surface[i,j].Xd,Surface[i,j].Yd);
        Image1.Picture.Bitmap.Canvas.LineTo(Surface[i,succ(j)].Xd,Surface[i,Succ(j)].Yd);
       end;
    i:=succ(MaxI);
    For j:=0 to MaxJ do
       begin
        A[1]:=Surface[i,j].Xd;A[2]:=Surface[i,j].Yd;
        B[1]:=Surface[i,succ(j)].Xd;B[2]:=Surface[i,succ(j)].Yd;
        Image1.Picture.Bitmap.Canvas.MoveTo(Surface[i,j].Xd,Surface[i,j].Yd);
        Image1.Picture.Bitmap.Canvas.LineTo(Surface[i,succ(j)].Xd,Surface[i,Succ(j)].Yd);
       end;
    j:=succ(MaxJ);
    For i:=0 to MaxI do
       begin
        A[1]:=Surface[i,j].Xd;A[2]:=Surface[i,j].Yd;
        B[1]:=Surface[Succ(i),j].Xd;B[2]:=Surface[Succ(i),j].Yd;
        Image1.Picture.Bitmap.Canvas.MoveTo(Surface[i,j].Xd,Surface[i,j].Yd);
        Image1.Picture.Bitmap.Canvas.LineTo(Surface[Succ(i),j].Xd,Surface[succ(i),j].Yd);
       end;
   end;    
   t2:=Time;
   CanvasMiliseconds:=Trunc((t2-t1)/1.1574e-8);
   Str(CanvasMiliseconds,Vypis);
   EditCanvasMs.Text:=Vypis;
   if Miliseconds>0 then
            Str(MiliSeconds/Trunc((t2-t1)/1.1574e-8):7:5,Vypis)
                    else Vypis:='Infinity';
   if (CanvasMiliseconds>-1) and (Miliseconds>-1) then EditRatio.Text:=Vypis;
   Scan_Button.Enabled:=True;
end;

procedure TControl_Panel.FuncCalcul(Sender: TObject);
begin
 Setting;
 Func_Values;
 Scale(x1,x2,y1,y2);
 SetCenter(AlfaView,BetaView,Distance,Center);
 View(AlfaView,BetaView);
 Projection;
 Canvas_Button.Enabled:=True;
end;


end.
